<?php

/**
 * This software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ and is a proprietary licensed product.
 * For more information see License.txt in the plugin folder.

 * ---
 * Copyright (c) 2018, Ebenezer Obasi
 * All rights reserved.
 * info@eobasi.com.

 * Redistribution and use in source and binary forms, with or without modification, are not permitted provided.

 * This plugin should be bought from the developer. For details contact info@eobasi.com.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

 /**
 * MASTERLOGIN_BOL_Service
 *
 * @author Ebenezer Obasi <info@eobasi.com>
 * @package ow_plugins.masterlogin.bol
 * @since 1.8.4
 */

class MASTERLOGIN_BOL_Service
{
	const SESSION_USER = 'masterlogin.admin-user-id';

    /**
     *
     * @var OW_Session
     */
    private $session;

    /**
     *
     * @return MASTERLOGIN_BOL_Service
     */

    private static $classInstance;

    public static function getInstance()
    {
      if ( null === self::$classInstance )
      {
          self::$classInstance = new self();
      }

      return self::$classInstance;
    }

    private function __construct()
    {
        $this->session = OW::getSession();
    }

    public function getAdmin( )
    {
        return $this->session->get( self::SESSION_USER );
    }

    public function setAdmin( $userId )
    {
		$this->session->set( self::SESSION_USER,  $userId );
    }

    public function isAdminSet( )
    {
        return $this->session->isKeySet( self::SESSION_USER );
    }

    public function deleteAdmin( )
    {
        return $this->session->delete( self::SESSION_USER );
    }
}