<?php

/**
 * This software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ and is a proprietary licensed product.
 * For more information see License.txt in the plugin folder.

 * ---
 * Copyright (c) 2018, Ebenezer Obasi
 * All rights reserved.
 * info@eobasi.com.

 * Redistribution and use in source and binary forms, with or without modification, are not permitted provided.

 * This plugin should be bought from the developer. For details contact info@eobasi.com.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

 /**
 * MASTERLOGIN_CTRL_Auth
 *
 * @author Ebenezer Obasi <info@eobasi.com>
 * @package ow_plugins.masterlogin.controllers
 * @since 1.8.4
 */
class MASTERLOGIN_CTRL_Auth extends OW_ActionController
{
	private $userService;
	private $service;

	public function __construct()
	{
		$this->userService = BOL_UserService::getInstance();
		$this->service = MASTERLOGIN_BOL_Service::getInstance();
	}

    public function login( $params )
    {
		$user = $this->userService->findUserById( (int)$params['uid'] );

		if( !OW::getUser()->isAuthenticated() || !OW::getUser()->isAdmin() || empty( $user ) )
		{
			throw new Redirect403Exception();
		}

        $currentUserId = OW::getUser()->getId();

        OW::getUser()->logout( $currentUserId );
        OW::getUser()->login( $user->id );

		$this->service->setAdmin( $currentUserId );

		OW::getFeedback()->info(OW::getLanguage()->text('masterlogin', 'login_success', array('displayName' => $this->userService->getDisplayName( $user->id ))));

        $this->redirect( OW::getRouter()->getBaseUrl( ) );
    }

    public function back( )
    {
		if( !OW::getUser()->isAuthenticated() || !$this->service->isAdminSet( ) )
		{
			throw new Redirect403Exception();
		}

		$userId = $this->service->getAdmin( );

        OW::getUser()->logout( OW::getUser()->getId() );
        OW::getUser()->login( $userId );

		OW::getFeedback()->info(OW::getLanguage()->text('masterlogin', 'login_success', array('displayName' => $this->userService->getDisplayName( $userId ))));

        $this->redirect( OW::getRouter()->getBaseUrl( ) );
    }
}